﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
import javafx.animation.Interpolator;
import javafx.animation.KeyFrame;
import javafx.animation.KeyValue;
import javafx.animation.Timeline;
import javafx.animation.TimelineBuilder;
import javafx.application.Application;
import javafx.beans.binding.DoubleBinding;
import javafx.beans.property.DoubleProperty;
import javafx.beans.property.SimpleDoubleProperty;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.transform.Rotate;
import javafx.stage.Stage;
import javafx.util.Duration;

public class TimeRotate extends Application {
  public static void main(String[] args) {
    Application.launch(args);
  }
  
  @Override
  public void start(Stage primaryStage) {
    primaryStage.setTitle("Rotate");
    primaryStage.setWidth(400);
    primaryStage.setHeight(400);
    
    Text text;
    
    Scene scene = new Scene(new Group(text = new Text("Hello Rotate")));
        
    DoubleBinding pivotX = scene.widthProperty().divide(2);
    DoubleBinding pivotY = scene.heightProperty().divide(2);
    
    text.setFont(new Font(24));
    text.xProperty().bind(pivotX);
    text.yProperty().bind(pivotY);
    
    Rotate rotate;
    
    text.getTransforms().add(rotate = new Rotate());
    
    rotate.pivotXProperty().bind(pivotX);
    rotate.pivotYProperty().bind(pivotY);
    
    DoubleProperty angle = new SimpleDoubleProperty();
    
    rotate.angleProperty().bind(angle);
    
    Timeline rotateTimeline = TimelineBuilder.create()
        .cycleCount(Timeline.INDEFINITE)
        .keyFrames(
          new KeyFrame(Duration.ZERO, new KeyValue(angle, 0)),
          new KeyFrame(Duration.seconds(5), new KeyValue(angle, 360, Interpolator.EASE_OUT))
        ).build();
    
    rotateTimeline.play();
    
    primaryStage.setScene(scene);
    primaryStage.show();
  }
}
